﻿@model IEnumerable<ExploreApilkasiCuti.Models.MasterKaryawan>

@{
    ViewBag.Title = "Master Karyawan";
    Layout = "~/Views/Shared/_Layout.cshtml";
}
@section HeadLibrary{
    <!-- DataTables -->
    <link rel="stylesheet" href="~/AdminLTE/plugins/datatables-bs4/css/dataTables.bootstrap4.min.css">
    <link rel="stylesheet" href="~/AdminLTE//plugins/datatables-responsive/css/responsive.bootstrap4.min.css">
    <!-- SweetAlert2 -->
    <link rel="stylesheet" href="~/AdminLTE/plugins/sweetalert2-theme-bootstrap-4/bootstrap-4.min.css">
    <!-- Toastr -->
    <link rel="stylesheet" href="~/AdminLTE/plugins/toastr/toastr.min.css">

    <!-- iCheck for checkboxes and radio inputs -->
    <link rel="stylesheet" href="~/AdminLTE/plugins/icheck-bootstrap/icheck-bootstrap.min.css">
    <!-- Bootstrap Color Picker -->
    <link rel="stylesheet" href="~/AdminLTE/plugins/bootstrap-colorpicker/css/bootstrap-colorpicker.min.css">
    <!-- Select2 -->
    <link rel="stylesheet" href="~/AdminLTE/plugins/select2/css/select2.min.css">
    <link rel="stylesheet" href="~/AdminLTE/plugins/select2-bootstrap4-theme/select2-bootstrap4.min.css">
    <!-- Bootstrap4 Duallistbox -->
    <link rel="stylesheet" href="~/AdminLTE/plugins/bootstrap4-duallistbox/bootstrap-duallistbox.min.css">
    <!-- Theme style -->
    <link rel="stylesheet" href="~/AdminLTE/dist/css/adminlte.min.css">
}
<style>
    .help-block {
        color: red;
    }
</style>
<!-- Main content -->
<div class="card">
    <div class="card-header">
        <h3 class="card-title"> Master Data Karyawan</h3>
    </div>
    <!-- /.card-header -->
    <div class="card-body">
        <div class="row">
            <button type="button" class="btn btn-success" onclick="addKaryawan()">
                <i class="fa fa-plus-circle fa"></i>  Tambah Data
            </button>
            <div class="mt-3 col-md-12"></div>
        </div>
        <!-- Custom Filter -->
        <div class="card card-default collapsed-card">
            <div class="card-header">
                <h2 class="card-title">Custom Filter</h2>
                <div class="card-tools">
                    <button type="button" class="btn btn-tool" data-card-widget="collapse"><i class="fas fa-plus"></i></button>
                    @*<button type="button" class="btn btn-tool" data-card-widget="remove"><i class="fas fa-times"></i></button>*@
                </div>
            </div>

            <div class="card-body" style="display: none;">
                <form role="form" id="form-filter">
                    <div class="row">
                        <div class="col-md-6">
                            <div class="form-group">
                                <label>Bergabung setelah tanggal..</label>
                                <div class="input-group date" data-target-input="nearest">
                                    <input type="text" class="form-control datetimepicker-input" id="FilterStartDate" data-target="#FilterStartDate" data-date-format="MM-DD-YYYY" />
                                    <div class="input-group-append" id="FilterStartDate" data-target="#FilterStartDate" data-toggle="datetimepicker">
                                        <div class="input-group-text" id="FilterStartDate" placeholder="Masukkan Tanggal"><i class="fa fa-calendar"></i></div>
                                    </div>
                                </div>
                            </div>
                            <div class="form-group">
                                <div class="form-group">
                                    <label for="FilterJabatan">Jabatan</label>
                                    <select class="form-control select2" id="FilterJabatan" style="width: 100%;">
                                    </select>
                                </div>
                            </div>
                            <div class="form-group">
                                <label for="AllButton" class="col-sm-3 control-label"></label>
                                <div class="col-sm-4">
                                    <button type="button" id="btn-filter" class="btn btn-primary">Filter</button>
                                    <button type="reset" id="btn-reset" class="btn btn-default">Reset</button>
                                </div>
                            </div>
                        </div>
                        <!-- /.col -->
                        <div class="col-md-6">
                            <div class="form-group">
                                <label>Bergabung sebelum tanggal..</label>
                                <div class="input-group date" data-target-input="nearest">
                                    <input type="text" class="form-control datetimepicker-input" id="FilterEndDate" data-target="#FilterEndDate" data-date-format="MM-DD-YYYY" />
                                    <div class="input-group-append" id="FilterEndDate" data-target="#FilterEndDate" data-toggle="datetimepicker">
                                        <div class="input-group-text" id="FilterEndDate" placeholder="Masukkan Tanggal"><i class="fa fa-calendar"></i></div>
                                    </div>
                                </div>
                            </div>
                            <!-- /.form-group -->
                            <div class="form-group">
                                <label for="status">Status</label>
                                <select class="form-control select2" id="FilterStatus" style="width: 100%;">
                                    <option value="">----- All Status -----</option>
                                    @*<option value="1">Active</option>
                                        <option value="0">Not Active</option>*@
                                </select>
                            </div>
                            <!-- /.form-group -->
                        </div>
                        <!-- /.col -->
                    </div>
                    <!-- /.row -->
                </form>
            </div>
            <!-- /.card-body -->
        </div>
        <!-- /.card -->

        <table id="dataMasterKaryawan" class="table table-bordered table-striped table-hover" role="grid" aria-describedby="dataMasterKaryawan_info" style="width:100%">
            <thead>
                <tr>
                    <th>
                        @Html.DisplayName("ID Karyawan")
                    </th>
                    <th>
                        @Html.DisplayName("Nama")
                    </th>
                    <th>
                        @Html.DisplayName("Tgl Bergabung")
                    </th>
                    <th>
                        @Html.DisplayName("Jabatan")
                    </th>
                    <th>
                        @Html.DisplayName("Status")
                    </th>
                    <th>
                        @Html.DisplayName("Action")
                    </th>
                </tr>
            </thead>
        </table>

    </div>
    <!-- /.card-body -->
</div>
<!-- /.card -->
<!-- /.content -->
<!-- /.modal Add start -->
<div class="modal fade" id="modal_form">
    <div class="modal-dialog modal-lg">
        <div class="modal-content">
            <div class="modal-header">
                <h4 class="modal-title">Karyawan Form</h4>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="card card-primary">
                <!-- form start -->
                <form role="form" id="form_karyawan">
                    <div class="card-body">
                        <div class="form-group">
                            <label for="IDKaryawan">ID Karyawan</label>
                            <input name="IDKaryawan" placeholder="ID Karyawan" id="IDKaryawan" class="form-control" type="text">
                            <span id="span_id_karyawan" class="help-block"></span>
                        </div>
                        <div class="form-group">
                            <label for="NamaKaryawan">Nama Karyawan</label>
                            <input name="NamaKaryawan" placeholder="Nama Karyawan" id="NamaKaryawan" class="form-control" type="text">
                            <span id="span_nama_karyawan" class="help-block"></span>
                        </div>
                        <div class="form-group">
                            <label for="AlamatKaryawan">Alamat</label>
                            <input name="AlamatKaryawan" placeholder="Alamat Karyawan" id="AlamatKaryawan" class="form-control" type="text">
                        </div>
                        <div class="form-group">
                            <label for="EmailKaryawan">Email</label>
                            <input name="EmailKaryawan" placeholder="Email Karyawan" id="EmailKaryawan" class="form-control" type="email">
                            <span id="span_email" class="help-block"></span>
                        </div>
                        <div class="form-group">
                            <label for="NoTelpKaryawan">No Telp</label>
                            <input type="number" name="NoTelpKaryawan" placeholder="No Telp" id="NoTelpKaryawan" class="form-control">
                        </div>
                        <div class="form-group">
                            <label>Tanggal Bergabung</label>
                            <div class="input-group date" data-target-input="nearest">
                                <input type="text" class="form-control datetimepicker-input" id="JoinDate" data-target="#JoinDate" data-date-format="MM-DD-YYYY" />
                                <div class="input-group-append" id="JoinDate" data-target="#JoinDate" data-toggle="datetimepicker">
                                    <div class="input-group-text" id="JoinDate" placeholder="Masukkan Tanggal Bergabung"><i class="fa fa-calendar"></i></div>
                                </div>
                            </div>
                            <span id="span_join_date" class="help-block"></span>
                        </div>
                        <div class="form-group">
                            <label for="SelectIDJabatan">Jabatan</label>
                            <select class="form-control select2" id="SelectIDJabatan" style="width: 100%;">
                            </select>
                            <span id="span_id_jabatan" class="help-block"></span>
                        </div>
                        <div class="form-group">
                            <label for="SelectIDGroup">Group</label>
                            <select class="form-control select2" id="SelectIDGroup" style="width: 100%;">
                            </select>
                            <span id="span_id_group" class="help-block"></span>
                        </div>
                        <div class="form-group">
                            <label for="SelectStatus">Status</label>
                            <select name="SelectStatus" id="SelectStatus" class="form-control select2" style="width: 100%;">
                                <option>Aktif</option>
                                <option>Tidak Aktif</option>
                            </select>
                        </div>
                    </div>
                    <!-- /.card-body -->

                    <div class="card-footer d-flex">
                        <button type="button" id="btnSave" onclick="save()" class="btn btn-primary mx-auto" style="width:35%">Simpan Data</button>
                        <button type="button" class="btn btn-danger mx-auto" data-dismiss="modal" style="width:35%">Batalkan</button>
                    </div>
                </form>
            </div>
        </div>
        <!-- /.modal-content -->
    </div>
    <!-- /.modal-dialog -->
</div>
<!-- /.modal Add end -->
<!-- /.modal Detail start -->
<div class="modal fade" id="modal_detail">
    <div class="modal-dialog modal-lg">
        <div class="modal-content">
            <div class="modal-header">
                <h4 class="modal-title">Karyawan Form</h4>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="card card-primary">
                <div class="card-header">
                    <h3 class="card-title"><strong><span id="Detail_IDKaryawan"></span></strong></h3>
                </div>
                <!-- /.card-header -->
                <div class="card-body">
                    <strong>Nama Karyawan</strong>
                    <p class="text-muted">
                        <i class="fas fa-user-alt mr-1"></i> <span id="Detail_NamaKaryawan"></span>
                    </p>
                    <hr>

                    <strong>Alamat</strong>
                    <p class="text-muted">
                        <i class="fas fa-map-marker-alt mr-1"></i> <span id="Detail_AlamatKaryawan"></span>
                    </p>
                    <hr>

                    <strong>Email</strong>
                    <p class="text-muted">
                        <i class="fas fa-envelope-open mr-1"></i> <span id="Detail_EmailKaryawan"></span>
                    </p>
                    <hr>

                    <strong>Nomor Telepon</strong>
                    <p class="text-muted">
                        <i class="fas fa-phone-alt mr-1"></i> <span id="Detail_NoTelpKaryawan"></span>
                    </p>
                    <hr>

                    <strong>Tanggal Bergabung</strong>
                    <p class="text-muted">
                        <i class="fas fa-calendar-alt mr-1"></i> <span id="Detail_JoinDate"></span>
                    </p>
                    <hr>

                    <strong>Jabatan</strong>
                    <p class="text-muted">
                        <i class="fas fa-briefcase mr-1"></i> <span id="Detail_Jabatan"></span>
                    </p>
                    <hr>

                    <strong>Group</strong>
                    <p class="text-muted">
                        <i class="fas fa-briefcase mr-1"></i> <span id="Detail_Group"></span>
                    </p>
                    <hr>

                    <strong>Status Saat Ini</strong>
                    <p class="text-muted">
                        <i class="fas fa-circle mr-1"></i> <span id="Detail_Status"></span>
                    </p>
                    <hr>
                </div>
                <!-- /.card-body -->
                <div class="card-footer">
                    <button type="button" id="btnClose" onclick="closeModalDetail()" class="btn btn-outline-primary" style="display:none;">Close</button>
                </div>
            </div>
            <!-- /.card -->
        </div>
        <!-- /.modal-content -->
    </div>
    <!-- /.modal-dialog -->
</div>
<!-- /.modal Detail end -->
@section BodyLibrary{
    <!-- DataTables -->
    <script src="@Url.Content("~/AdminLTE/plugins/datatables/jquery.dataTables.min.js")"></script>
    <script src="@Url.Content("~/AdminLTE/plugins/datatables-bs4/js/dataTables.bootstrap4.min.js")"></script>
    <script src="@Url.Content("~/AdminLTE/plugins/datatables-responsive/js/dataTables.responsive.min.js")"></script>
    <script src="@Url.Content("~/AdminLTE/plugins/datatables-responsive/js/responsive.bootstrap4.min.js")"></script>
    <!-- SweetAlert2 -->
    <script src="@Url.Content("~/AdminLTE/plugins/sweetalert2/sweetalert2.min.js")"></script>
    <!-- Toastr -->
    <script src="@Url.Content("~/AdminLTE/plugins/toastr/toastr.min.js")"></script>
    <!-- DataRender -->
    <script src="@Url.Content("~/AdminLTE/plugins/dataRender/dateTime.js")"></script>
    <script src="@Url.Content("~/AdminLTE/plugins/jsgrid/demos/db.js")"></script>
    <script src="@Url.Content("~/AdminLTE/plugins/jsgrid/jsgrid.min.js")"></script>
    <!-- Select2 -->
    <script src="@Url.Content("~/AdminLTE/plugins/select2/js/select2.full.min.js")"></script>
    <!-- Bootstrap Switch -->
    <script src="@Url.Content("~/AdminLTE/plugins/bootstrap-switch/js/bootstrap-switch.min.js")"></script>
    <!-- bootstrap color picker -->
    <script src="@Url.Content("~/AdminLTE/plugins/bootstrap-colorpicker/js/bootstrap-colorpicker.min.js")"></script>
    <!-- Select2 -->
    <script src="~/AdminLTE/plugins/select2/js/select2.full.min.js"></script>
    <!-- jquery-validation -->
    <script src="~/AdminLTE/plugins/jquery-validation/jquery.validate.min.js"></script>
    <script src="~/AdminLTE/plugins/jquery-validation/additional-methods.min.js"></script>
}


@section AdditionalScript{
    <script>

        var rowId;
        var rowName;
        var masterKaryawanTable;
        
        jQuery(document).ready(function ($) {


            masterKaryawanTable = $("#dataMasterKaryawan").DataTable({

                "responsive": true,
                "autoWidth": false,
                "ajax": {
                    "url": '@Url.Action("GetData")',
                    "type": "POST",
                    "datatype": "JSON",
                    "data": function (data) {
                        data.FilterJabatan = $('#FilterJabatan').val();
                        data.FilterStartDate = $('#FilterStartDate').val();
                        data.FilterEndDate = $('#FilterEndDate').val();
                        data.FilterStatus = $('#FilterStatus').val();
                    }
                },

                "columns": [
                    { "data": "id_karyawan", "name": "id_karyawan" },
                    { "data": "nama", "name": "nama" },
                    {"data": "join_date","name": "join_date"},
                    { "data": "nama_jabatan", "name": "nama_jabatan" },
                    { "data": "status", "name": "status" },
                    {
                        data: null, render: function (data, type, row) {
                            return '<button type="button" data-toggle="modal" class="btn btn-sm btn-icon btn-icon rounded-circle bg-gradient-primary waves-effect waves-light" style="margin-right: 5px;" onclick="viewKaryawan(\'' + data.id_karyawan + '\')"><i class="fas fa-eye"></i></button>   <button type="button" data-toggle="modal" class="btn btn-sm btn-icon btn-icon rounded-circle bg-gradient-secondary waves-effect waves-light" style="margin-right: 5px;" onclick="editKaryawan(\'' + data.id_karyawan + '\')"><i class="fas fa-edit"></i></button>   <button type="button" class="btn btn-sm btn-icon btn-icon rounded-circle bg-gradient-danger waves-effect waves-light" onclick="deleteKaryawan(\'' + data.id_karyawan + '\')"><i class="fa fa-trash-alt"></i></button>'

                        }

                    },
                ],

            });
            $('.select2').select2();

            loadDataSelect2();
            $('#SelectStatus').select2({
                width: '100%',
                theme: 'bootstrap4',
            });
            $('#FilterStatus').select2({
                multiple: false,
                allowClear: true,
                data: [
                    {
                        id: "active",
                        text: 'Aktif'
                    },
                    {
                        id: "inactive",
                        text: 'Tidak Aktif'
                    }],
                width: '100%',
                theme: 'bootstrap4',
                placeholder: '--- Pilih Status ---',
            });
            @*
            $('#SelectIDJabatan').select2({
                dropdownParent: $('#modal_form'),
                multiple: false,
                allowClear: true,
                placeholder: '--- Pilih Jabatan ---',
                width: '100%',
                theme: 'bootstrap4',
                search:true,
                ajax: {
                    url: '@Url.Content("~/MasterJabatan/GetDataJabatan")',
                    dataType: 'JSON',
                    type: "POST",
                    delay: 250,
                    processResults: function (data) {
                        return {
                            results: $.map(data, function (item) {
                                return {
                                    text: item.nama_jabatan,
                                    id: item.id_jabatan,
                                }
                            })
                        };
                    },
                    cache: true
                }
            });

            $('#SelectIDGroup').select2({
                multiple: false,
                allowClear: true,
                placeholder: '--- Pilih Group ---',
                width: '100%',
                theme: 'bootstrap4',
                search:true,
                ajax: {
                    url: '@Url.Content("~/GroupAccess/GetDataGroup")',
                    dataType: 'JSON',
                    type: "POST",
                    delay: 250,
                    processResults: function (data) {
                        return {
                            results: $.map(data, function (item) {
                                return {
                                    text: item.nama_group,
                                    id: item.id_group,
                                }
                            })
                        };
                    },
                    cache: true
                }
            });

            $('#FilterJabatan').select2({
                multiple: false,
                allowClear: true,
                placeholder: '--- Pilih Jabatan ---',
                width: '100%',
                theme: 'bootstrap4',
                ajax: {
                    url: '@Url.Content("~/MasterJabatan/GetDataJabatan")',
                    dataType: 'JSON',
                    type: "POST",
                    delay: 250,
                    processResults: function (data) {
                        return {
                            results: $.map(data, function (item) {
                                return {
                                    text: item.nama_jabatan,
                                    id: item.id_jabatan,
                                }
                            })
                        };
                    },
                    cache: true
                }
            });
            *@
            $('#JoinDate').datetimepicker({
                format: 'L'
            });
            $('#FilterStartDate').datetimepicker({
                format: 'L'
            });
            $('#FilterEndDate').datetimepicker({
                format: 'L'
            });
        });

        $('#btn-filter').click(function () { //button filter event click
            masterKaryawanTable.ajax.reload(); //just reload table
        });
        $('#btn-reset').click(function () { //button filter event click
            document.getElementById("form-filter").reset();
            $('#FilterJabatan').empty();
            $("#FilterStatus").val(null).trigger("change");
            setTimeout(function () {
                masterKaryawanTable.ajax.reload();
            }, 250);

        });
        function loadDataSelect2() {

            $.ajax({
                url: '@Url.Content("~/GroupAccess/GetDataGroup")',
                type: 'POST',
                dataType: 'json',
                delay: 250,
                processResults: function (data) {
                    return {
                        results: $.map(data['data'], function (item) {
                            return {
                                text: item.nama_group,
                                id: item.id_group,
                            }
                        })
                    };
                }
            }).then(
                function (response) {
                    $('#SelectIDGroup').select2({
                        multiple: false,
                        allowClear: true,
                        placeholder: '- Pilih Group -',
                        width: '100%',
                        //theme: 'bootstrap4',
                        data: $.map(response.data, function (item) {
                            return {
                                text: item.nama_group,
                                id: item.id_group,
                            }
                        })
                    });
                }
            );
            //id jabatan
            $.ajax({
                url: '@Url.Content("~/MasterJabatan/GetDataJabatan")',
                type: 'POST',
                dataType: 'json',
                delay: 250,
                processResults: function (data) {
                    return {
                        results: $.map(data['data'], function (item) {
                            return {
                                text: item.nama_jabatan,
                                id: item.id_jabatan,
                            }
                        })
                    };
                }
            }).then(
                function (response) {
                    $('#SelectIDJabatan').select2({
                        multiple: false,
                        allowClear: true,
                        placeholder: '- Pilih Jabatan -',
                        width: '100%',
                        //theme: 'bootstrap4',
                        data: $.map(response.data, function (item) {
                            return {
                                text: item.nama_jabatan,
                                id: item.id_jabatan,
                            }
                        })
                    });
                }
            );

            $.ajax({
                url: '@Url.Content("~/MasterJabatan/GetDataJabatan")',
                type: 'POST',
                dataType: 'json',
                delay: 250,
                processResults: function (data) {
                    return {
                        results: $.map(data['data'], function (item) {
                            return {
                                text: item.nama_jabatan,
                                id: item.id_jabatan,
                            }
                        })
                    };
                }
            }).then(
                function (response) {
                    $('#FilterJabatan').select2({
                        multiple: false,
                        allowClear: true,
                        placeholder: '- Pilih Jabatan -',
                        width: '100%',
                        //theme: 'bootstrap4',
                        data: $.map(response.data, function (item) {
                            return {
                                text: item.nama_jabatan,
                                id: item.id_jabatan,
                            }
                        })
                    });
                }
            );
            $('#FilterJabatan').append($("<option/>").val('').text('')).val('');

        }
        function viewKaryawan(id_karyawan) {
            document.getElementById('btnClose').style.display = 'block';
            $('.help-block').empty();
            document.getElementById("form_karyawan").reset();
            $('#SelectIDJabatan').empty();
            $('#SelectIDGroup').empty();
            $('.modal-title').text('Lihat Data Karyawan');
            var m_names = new Array("Januari", "Februari", "Maret",
                "April", "Mei", "Juni", "Juli", "Agustus", "September",
                "Oktober", "November", "Desember");
            $.ajax({
                url: '@Url.Action("GetDataByID")' + "/" + id_karyawan,
                    method: "POST",
                    dataType: "JSON",
                    beforeSend: function () {
                        Swal.fire({
                            title: 'Loading...',
                            html: "Loading Data.",
                            allowOutsideClick: false,
                            onBeforeOpen: () => {
                                Swal.showLoading()
                            }
                        });
                    },
                    success: function (result) {
                        if (result.metaData.code === '200') {
                            Swal.close();
                            $('#Detail_IDKaryawan').text(result.response[0].id_karyawan);
                            $('#Detail_NamaKaryawan').text(result.response[0].nama);
                            $('#Detail_AlamatKaryawan').text(result.response[0].alamat);
                            $('#Detail_NoTelpKaryawan').text(result.response[0].no_telp);
                            $('#Detail_EmailKaryawan').text(result.response[0].email);
                            var d = new Date(result.response[0].join_date);
                            $('#Detail_JoinDate').text(d.getDate() + " " + m_names[d.getMonth()] + " " + d.getFullYear());
                            //$('#Detail_JoinDate').text(result.response[0].join_date);
                            $('#Detail_Jabatan').text(result.response[0].nama_jabatan);
                            getGroupName(result.response[0].id_group);
                            $('#Detail_Status').text(result.response[0].status);

                            $('#modal_detail').modal('show');
                        } else {
                            return toastr.warning(result.metaData.message, 'Sorry!', { "timeOut": 5000 });
                        }
                    },
                    error: function (eventError, textStatus, errorThrown) {
                        return toastr.error(formatErrorMessage(eventError, errorThrown), 'Failed!', { "timeOut": 5000 });
                    }
                });
        }

        function unselect_select2() {
            $('#SelectIDJabatan').append($("<option/>").val('').text('')).val('');
            $('#SelectIDGroup').append($("<option/>").val('').text('')).val('');
            $('#SelectIDJabatan').val('').trigger("change");
            $('#SelectIDGroup').val('').trigger("change");

        }
        function addKaryawan() {
           save_method = 'add';
            $('.help-block').empty();
            document.getElementById("form_karyawan").reset();
            $('#SelectIDJabatan').empty();
            $('#SelectIDGroup').empty();
            loadDataSelect2();
            unselect_select2();
            $('#IDKaryawan').attr("readonly", false);
            $('.modal-title').text('Tambah Data Karyawan');
            $('#modal_form').modal('show');
        }

        function editKaryawan(id_karyawan) {
            save_method = 'update';
            $('.help-block').empty();
            document.getElementById("form_karyawan").reset();
            unselect_select2();
            unselect_select2();
            $('.modal-title').text('Edit Data Karyawan');
            $.ajax({
                url: '@Url.Action("GetDataByID")' + "/" + id_karyawan,
                    method: "POST",
                    dataType: "JSON",
                    beforeSend: function () {
                        Swal.fire({
                            title: 'Loading...',
                            html: "Loading Data.",
                            allowOutsideClick: false,
                            onBeforeOpen: () => {
                                Swal.showLoading()
                            }
                        });
                    },
                    success: function (result) {
                        if (result.metaData.code === '200') {
                            Swal.close();
                            $('#IDKaryawan').val(result.response[0].id_karyawan).trigger('change');
                            $('#NamaKaryawan').val(result.response[0].nama).trigger('change');
                            $('#AlamatKaryawan').val(result.response[0].alamat).trigger('change');
                            $('#NoTelpKaryawan').val(result.response[0].no_telp).trigger('change');
                            $('#EmailKaryawan').val(result.response[0].email).trigger('change');
                            $('#JoinDate').val(result.response[0].join_date);
                            //$('#SelectIDJabatan').append($("<option/>").val(result.response[0].id_jabatan).text(result.response[0].nama_jabatan)).val(result.response[0].id_jabatan);
                            $('#SelectIDJabatan').val(result.response[0].id_jabatan).trigger("change");
                            //$('#SelectIDGroup').empty().append($("<option/>").val(result.response[0].id_group).text(result.response[0].nama_group)).val(result.response[0].id_group);
                            getGroupName(result.response[0].id_group);
                            $('#SelectStatus').val(result.response[0].status).trigger('change');
                            $('#IDKaryawan').attr("readonly", true);
                            $('#modal_form').modal('show');
                        } else {
                            return toastr.warning(result.metaData.message, 'Sorry!', { "timeOut": 5000 });
                        }
                    },
                    error: function (eventError, textStatus, errorThrown) {
                        return toastr.error(formatErrorMessage(eventError, errorThrown), 'Failed!', { "timeOut": 5000 });
                    }
                });
        }

        function closeModalDetail() {
            $('#modal_detail').modal('hide');
        }

        function save() {
            var validate = true;
            var url;
            var mailformat = /^(([^<>()[\]\\.,;:\s@@"]+(\.[^<>()[\]\\.,;:\s@@"]+)*)|(".+"))@@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
            if ($('#IDKaryawan').val() == "") {
                $('#span_id_karyawan').text('ID Karyawan Harus diisi');
                validate = false;
            }
            if ($('#NamaKaryawan').val() == "") {
                $('#span_nama_karyawan').text('Nama Karyawan Harus diisi');
                validate = false;
            }
            if ($('#EmailKaryawan').val() == "") {
                $('#span_email').text('Email Karyawan Harus diisi');
                validate = false;
            }
            if ($('#JoinDate').val() == "") {
                $('#span_join_date').text('Join Date Karyawan Harus diisi');
                validate = false;
            }
            if ($('#SelectIDJabatan').val() == "") {
                $('#span_id_jabatan').text('Jabatan Karyawan Harus diisi');
                validate = false;
            }
            if ($('#SelectIDGroup').val() == "") {
                $('#span_id_group').text('Group Karyawan Harus diisi');
                validate = false;
            }
            
            if ($('#EmailKaryawan').val().match(mailformat)) {
                //validate = true;
            } else {
                $('#span_email').text('Masukkan email yang valid');
               validate = false;
            }
            if (!validate) {
                return;
            }

            $('#btnSave').text('Menyimpan...'); //change button textbtn_import_medion
            $('#btnSave').attr('disabled', true);

            if (save_method == 'add') {
                url = '@Url.Action("Create")';
            }
            else if (save_method == 'update') {
                url = "@Url.Action("Update")";
            }

            $.ajax({
                    url: url,
                    method: "POST",
                    dataType: "JSON",
                    data: {
                        "id_karyawan": $('#IDKaryawan').val(),
                        "nama": $('#NamaKaryawan').val(),
                        "alamat": $('#AlamatKaryawan').val(),
                        "no_telp": $('#NoTelpKaryawan').val(),
                        "email": $('#EmailKaryawan').val(),
                        "join_date": $('#JoinDate').val(),
                        "id_jabatan": $('#SelectIDJabatan').val(),
                        "id_group": $('#SelectIDGroup').val(),
                        "status": $('#SelectStatus').val(),
                    },
                    beforeSend: function () {
                        Swal.fire({
                            title: 'Processing...',
                            html: "Saving Data.",
                            allowOutsideClick: false,
                            onBeforeOpen: () => {
                                Swal.showLoading()
                            }
                        });
                    },
                    success: function (result) {
                        Swal.close();
                        if (result.metaData.code === '200') {
                            $('#modal_form').modal('hide');
                            masterKaryawanTable.ajax.reload();
                            $('#btnSave').text('Simpan Data'); //change button text
                            $('#btnSave').attr('disabled', false); //set button enable
                            return toastr.success('Data berhasil disimpan.', 'Berhasil!', { "timeOut": 5000 });
                        } else {
                            $('#btnSave').text('Simpan Data'); //change button text
                            $('#btnSave').attr('disabled', false); //set button enable
                            return toastr.warning(result.metaData.message, 'Sorry!', { "timeOut": 5000 });
                        }
                    },
                    error: function (eventError, textStatus, errorThrown) {
                        $('#btnSave').text('Simpan Data'); //change button text
                        $('#btnSave').attr('disabled', false); //set button enable
                        return toastr.error(formatErrorMessage(eventError, errorThrown), 'Failed!', { "timeOut": 5000 });
                    }
            });

        }

        function deleteKaryawan(id_karyawan) {
            Swal.fire({
                title: 'Perhatian',
                text: "Apakah anda Yakin menghapus data ?" ,
                type: 'warning',
                showCancelButton: true,
                confirmButtonColor: '#3085d6',
                cancelButtonColor: '#d33',
                confirmButtonText: 'Hapus Data',
                confirmButtonClass: 'btn btn-primary',
                cancelButtonClass: 'btn btn-danger ml-1',
                showLoaderOnConfirm: true,
                buttonsStyling: false,
                preConfirm: (delete_part) => {
                    return fetch('@Url.Action("DeleteKaryawan")' + "/" + id_karyawan, {
                        method: 'POST'
                    }).then(response => {
                        if (!response.ok) {
                            return toastr.error(response.statusText, 'Failed!', { "timeOut": 5000 });
                        }
                        return response.json();
                    }).then(result => {
                        if (result.metaData.code === '200') {
                            masterKaryawanTable.ajax.reload();
                            return toastr.success('Data berhasil dihapus.', 'Success!', { "timeOut": 5000 });
                        } else {
                            return toastr.warning(result.metaData.message, 'Sorry!', { "timeOut": 5000 });
                        }
                    }).catch(error => {
                        Swal.showValidationMessage(
                            `Request failed: ${error}`
                        )
                    })
                },
                allowOutsideClick: () => !Swal.isLoading()
            });
        }

        function getGroupName(id_group) {

             $.ajax({
                 url: '@Url.Content("~/GroupAccess/GetDataByID")' + "/" + id_group,
                    method: "POST",
                    dataType: "JSON",
                    success: function (result) {
                        if (result.metaData.code === '200') {
                            $('#Detail_Group').text(result.response[0].nama_group);
                           // $('#SelectIDGroup').append($("<option/>").val(result.response[0].id_group).text(result.response[0].nama_group)).val(result.response[0].id_group);
                            $('#SelectIDGroup').val(result.response[0].id_group).trigger("change");

                        } else {
                            return toastr.warning(result.metaData.message, 'Sorry!', { "timeOut": 5000 });
                        }
                    },
                    error: function (eventError, textStatus, errorThrown) {
                        return toastr.error(formatErrorMessage(eventError, errorThrown), 'Failed!', { "timeOut": 5000 });
                    }
                });
        }
    </script>
}